tag = 'AJT'
Eancom.register_segment(tag: tag, klass: Eancom::Edifact::AJT)

structure = Eancom::Edifact::Structure.new(tag: tag)
#==============================================================================
# Tag                                                                         #
#==============================================================================
tag = Eancom::Edifact::Composite.new
data = Eancom::Edifact::Data.new(
  type: String,
  length: 1..3,
  dictionary: nil,
  description: 'Message Header',
  required: true
)
tag.add(:tag, data)

structure << tag
#==============================================================================
# HAZARD CODE                                                                 #
#==============================================================================
adjustment_reason_description = Eancom::Edifact::Composite.new
data = Eancom::Edifact::Data.new(
  type: String,
  length: 1..3,
  dictionary: {
    '3' => {
      description: 'Damaged goods',
      identifier: 'damaged_goods'
    },
    '5' => {
      description: 'Price query',
      identifier: 'price_query'
    },
    '9' => {
      description: 'Invoice error',
      identifier: 'invoice_error'
    }
  },
  description: 'Adjustment reason description',
  required: true
)
adjustment_reason_description.add(:adjustment_reason_description, data)

structure << adjustment_reason_description
#==============================================================================
Eancom.register_structure(tag: 'AJT', structure: structure)
