tag = 'EFI'
Eancom.register_segment(tag: tag, klass: Eancom::Edifact::EFI)

structure = Eancom::Edifact::Structure.new(tag: tag)
#==============================================================================
# Tag                                                                         #
#==============================================================================
tag = Eancom::Edifact::Composite.new
data = Eancom::Edifact::Data.new(
  type: String,
  length: 1..3,
  dictionary: nil,
  description: 'Message Header',
  required: true
)
tag.add(:tag, data)

structure << tag
#==============================================================================
# FILE IDENTIFICATION                                                      #
#==============================================================================
file_name = Eancom::Edifact::Composite.new()

data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..3,
    dictionary: nil,
    description: 'File name',
    required: true
)
file_name.add(:file_name, data)

structure << file_name
#==============================================================================
# FILE DETAILS                                                    #
#==============================================================================
file_format_name = Eancom::Edifact::Composite.new()

data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..3,
    dictionary: nil,
    description: 'File format name',
    required: true
)
file_format_name.add(:file_format_name, data)

data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..3,
    dictionary: {
        '3' => {
            description: 'Binary',
            identifier: 'binary'
        },
        '4' => {
            description: 'Analogue',
            identifier: 'analogue'
        }
    },
    description: 'Data format description code',
    required: false
)
file_format_name.add(:data_format_description_code, data)
structure << file_format_name
#==============================================================================
Eancom.register_structure(tag: 'EFI', structure: structure)
