tag = 'EQD'
Eancom.register_segment(tag: tag, klass: Eancom::Edifact::EQD)

structure = Eancom::Edifact::Structure.new(tag: tag)
#==============================================================================
# Tag                                                                         #
#==============================================================================
tag = Eancom::Edifact::Composite.new
data = Eancom::Edifact::Data.new(
  type: String,
  length: 1..3,
  dictionary: nil,
  description: 'Message Header',
  required: true
)
tag.add(:tag, data)

structure << tag

equipment_code_qualifier = Eancom::Edifact::Composite.new
data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..3,
    dictionary: {
        'CN' => {
            description: 'Container',
            identifier: 'container'
        }
    },
    description: 'Equipment code qualifier',
    required: true
)
equipment_code_qualifier.add(:equipment_code_qualifier, data)

structure << equipment_code_qualifier
#==============================================================================
Eancom.register_structure(tag: 'EQD', structure: structure)