tag = 'GIN'
Eancom.register_segment(tag: tag, klass: Eancom::Edifact::GIN)

structure = Eancom::Edifact::Structure.new(tag: tag)
#==============================================================================
# Tag                                                                         #
#==============================================================================
tag = Eancom::Edifact::Composite.new()
data = Eancom::Edifact::Data.new(
  type: String,
  length: 3,
  dictionary: nil,
  description: "Message Header",
  required: true
)
tag.add(:tag, data)

structure << tag
#==============================================================================
# Object identification code qualifier
#==============================================================================
object_identification_code_qualifier = Eancom::Edifact::Composite.new()
data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..3,
    dictionary: {
        'BJ' => {
            description: 'Serial shipping container code',
            identifier: 'serial_shipping_container_code'
        },
        'SRV' => {
            description: 'GS1 Global Trade Item Number (GS1 Temporary Code)',
            identifier: 'gs1_global_trade_item_number'
        }
    },
    description: 'Object identification code qualifier',
    required: true
)
object_identification_code_qualifier.add(:object_identification_code_qualifier, data)

structure << object_identification_code_qualifier
#==============================================================================
# Identity number range
#==============================================================================
object_identifier_1 = Eancom::Edifact::Composite.new()
data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..35,
    dictionary: nil,
    description: 'Object identifier one',
    required: true
)
object_identifier_1.add(:object_identifier_1, data)

structure << object_identifier_1
#==============================================================================
# Identity number range
#==============================================================================
object_identifier_2 = Eancom::Edifact::Composite.new()
data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..35,
    dictionary: nil,
    description: 'Object identifier two',
    required: true
)
object_identifier_2.add(:object_identifier_2, data)

structure << object_identifier_2
#==============================================================================
# Identity number range
#==============================================================================
object_identifier_3 = Eancom::Edifact::Composite.new()
data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..35,
    dictionary: nil,
    description: 'Object identifier three',
    required: true
)
object_identifier_3.add(:object_identifier_3, data)

structure << object_identifier_3
#==============================================================================
# Identity number range
#==============================================================================
object_identifier_4 = Eancom::Edifact::Composite.new()
data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..35,
    dictionary: nil,
    description: 'Object identifier four',
    required: true
)
object_identifier_4.add(:object_identifier_4, data)

structure << object_identifier_4
#==============================================================================
# Identity number range
#==============================================================================
object_identifier_5 = Eancom::Edifact::Composite.new()
data = Eancom::Edifact::Data.new(
    type: String,
    length: 1..35,
    dictionary: nil,
    description: 'Object identifier five',
    required: true
)
object_identifier_5.add(:object_identifier_5, data)

structure << object_identifier_5

Eancom.register_structure(tag: 'GIN', structure: structure)