tag = 'RTE'
Eancom.register_segment(tag: tag, klass: Eancom::Edifact::RTE)

structure = Eancom::Edifact::Structure.new(tag: tag)
#==============================================================================
# Tag                                                                         #
#==============================================================================
tag = Eancom::Edifact::Composite.new
data = Eancom::Edifact::Data.new(
  type: String,
  length: 1..3,
  dictionary: nil,
  description: 'Message Header',
  required: true
)
tag.add(:tag, data)

structure << tag
#==============================================================================
# RATE DETAILS                                                                #
#==============================================================================
rate_details = Eancom::Edifact::Composite.new
data = Eancom::Edifact::Data.new(
  type: String,
  length: 1..3,
  dictionary: {
    '1' => {
      description: 'Allowance rate',
      identifier: 'allowance_rate'
    },
    '2' => {
      description: 'Charge rate',
      identifier: 'charge_rate'
    }
  },
  description: 'Rate type code qualifier',
  required: true
)
rate_details.add(:rate_type_code_qualifier, data)

data = Eancom::Edifact::Data.new(
  type: String,
  length: 1..15,
  dictionary: nil,
  description: 'Unit price basis rate',
  required: true
)
rate_details.add(:unit_price_basis_rate, data)

structure << rate_details
#===============================================================================#
Eancom.register_structure(tag: 'RTE', structure: structure)
