module Eancom
  module Edifact
    class CAV < Segment
      TAG = 'CAV'.freeze
      TYPE = :body.freeze

      attr_reader :segment_type

      def initialize(
        tag: nil,
        characterisitc_value_description_code: nil,
        code_list_identification_code: nil,
        code_list_respobsibility_agency_code: nil,
        characterisitc_value_description_1: nil,
        characterisitc_value_description_2: nil
      )
        @tag = tag
        @characterisitc_value_description_code = characterisitc_value_description_code
        @code_list_identification_code = code_list_identification_code
        @code_list_respobsibility_agency_code = code_list_respobsibility_agency_code
        @characterisitc_value_description_1 = characterisitc_value_description_1
        @characterisitc_value_description_2 = characterisitc_value_description_2

        super(tag: tag || TAG)
      end

      def to_json_hash
        hash = {}
        hash.merge!(characterisitc_value_description_code: find_identifier(:characterisitc_value_description_code)) if @characterisitc_value_description_code
        hash.merge!(code_list_identification_code: @code_list_identification_code) if @code_list_identification_code
        hash.merge!(code_list_respobsibility_agency_code: find_identifier(:code_list_respobsibility_agency_code)) if @code_list_respobsibility_agency_code
        hash.merge!(characterisitc_value_description_1: find_identifier(:characterisitc_value_description_1)) if @characterisitc_value_description_1
        hash.merge!(characterisitc_value_description_2: @characterisitc_value_description_2) if @characterisitc_value_description_2
        hash
      end

      def group_name
        'characterisitcs'
      end

      def segment_type
        TYPE
      end

    end
  end
end
