module Eancom
  module Edifact
    class CCI < Segment
      TAG = 'CCI'.freeze
      TYPE = :body.freeze

      attr_reader :segment_type

      def initialize(
        tag: nil,
        class_type_code: nil,
        measurment_attribute_code: nil,
        characteristic_description_code:,
        code_list_identification_code: nil,
        code_list_respobsibility_agency_code: nil,
        characterisitc_description_1: nil,
        characterisitc_description_2: nil
      )
        @tag = tag
        @class_type_code = class_type_code
        @measurment_attribute_code = measurment_attribute_code
        @characteristic_description_code = characteristic_description_code
        @code_list_identification_code = code_list_identification_code
        @code_list_respobsibility_agency_code = code_list_respobsibility_agency_code
        @characterisitc_description_1 = characterisitc_description_1
        @characterisitc_description_2 = characterisitc_description_2

        super(tag: tag || TAG)
      end

      def to_json_hash
        hash = {}
        hash.merge!(class_type_code: find_identifier(:class_type_code)) if @class_type_code
        hash.merge!(measurment_attribute_code: @measurment_attribute_code) if @measurment_attribute_code
        hash.merge!(characteristic_description_code: find_identifier(:characteristic_description_code)) if @characteristic_description_code
        hash.merge!(code_list_identification_code: @code_list_identification_code) if @code_list_identification_code
        hash.merge!(code_list_respobsibility_agency_code: find_identifier(:code_list_respobsibility_agency_code)) if @code_list_respobsibility_agency_code
        hash.merge!(characterisitc_description_1: @characterisitc_description_1) if @characterisitc_description_1
        hash.merge!(characterisitc_description_2: @characterisitc_description_2) if @characterisitc_description_2
        hash
      end

      def group_name
        'characterisitcs'
      end

      def segment_type
        TYPE
      end

    end
  end
end
