module Eancom
  module Edifact
    class CDI < Segment
      TAG = 'CDI'.freeze
      TYPE = :body.freeze

      attr_reader :segment_type

      def initialize(
        tag: nil,
        physical_or_logical_state_type_code_qualifier: nil
      )

        @tag = tag
        @physical_or_logical_state_type_code_qualifier = physical_or_logical_state_type_code_qualifier
        super(tag: @tag || TAG)
      end

      def to_json_hash
        hash = {}
        hash.merge!(physical_or_logical_state_type_code_qualifier: find_identifier(:physical_or_logical_state_type_code_qualifier)) if @physical_or_logical_state_type_code_qualifier
        hash
      end

      def segment_type
        TYPE
      end
    end
  end
end
