module Eancom
  module Edifact
    class CPS < Segment
      TAG = 'CPS'.freeze
      TYPE = :body.freeze

      def initialize(
        tag: nil,
        hierarchical_structure_level_identifier:,
        hierarchical_structure_parent_identifier: nil,
        packaging_level_code: nil
      )
        @tag = tag
        @hierarchical_structure_level_identifier = hierarchical_structure_level_identifier
        @hierarchical_structure_parent_identifier = hierarchical_structure_parent_identifier
        @packaging_level_code = packaging_level_code

        super(tag: tag || TAG)
      end

      def to_json_hash
        hash = {}
        hash.merge!(hierarchical_structure_level_identifier: @hierarchical_structure_level_identifier) if @hierarchical_structure_level_identifier
        hash.merge!(hierarchical_structure_parent_identifier: @hierarchical_structure_parent_identifier) if @hierarchical_structure_parent_identifier
        hash
      end

      def segment_type
        TYPE
      end
    end
  end
end
