module Eancom
  module Edifact
    class EFI < Segment
      TAG = 'EFI'.freeze
      TYPE = :body.freeze

      attr_reader :segment_type

      def initialize(
        tag: nil,
        file_name: nil,
        file_format_name:,
        data_format_description_code:
      )

        @tag = tag
        @file_name = file_name
        @file_format_name = file_format_name
        @data_format_description_code = data_format_description_code

        super(tag: tag || TAG)
      end
    

      def to_json_hash
        hash = {}
        hash.merge!(file_name: file_name) if @file_name
        hash.merge!(file_format_name: file_format_name) if @file_format_name
        hash.merge!(data_format_description_code: find_identifier(:data_format_description_code)) if @data_format_description_code
        hash
      end

      def segment_type
        TYPE
      end
    end
  end
end
