module Eancom
  module Edifact
    class INV < Segment
      TAG = 'INV'.freeze
      TYPE = :body

      attr_reader :segment_type

      def initialize(
        tag: nil,
        inventory_movement_direction_code:,
        inventory_type_code: nil,
        inventory_movement_reason_code: nil,
        inventory_balance_method_code: nil
      )

        @tag = tag
        @inventory_movement_direction_code = inventory_movement_direction_code
        @inventory_type_code = inventory_type_code
        @inventory_movement_reason_code = inventory_movement_reason_code
        @inventory_balance_method_code = inventory_balance_method_code
        super(tag: tag || TAG)
      end

      def to_json_hash
        hash = {}
        hash.merge!(inventory_movement_direction_code: find_identifier(:inventory_movement_direction_code)) if @inventory_movement_direction_code
        hash.merge!(inventory_type_code: @inventory_type_code) if @inventory_type_code
        hash.merge!(inventory_movement_reason_code: @inventory_movement_reason_code) if @inventory_movement_reason_code
        hash.merge!(inventory_balance_method_code: @inventory_balance_method_code) if @inventory_balance_method_code
        hash
      end
      
      def group_name
        'inventory'
      end

      def segment_type
        TYPE
      end
    end
  end
end
