module Eancom
  module Edifact
    class PCD < Segment
      TAG = 'PCD'.freeze
      TYPE = :header

      attr_reader :segment_type

      def initialize(
        tag: nil,
        percentage:,
        percentage_type_code_qualifier: nil
      )
        @tag = tag
        @percentage_type_code_qualifier = percentage_type_code_qualifier
        @percentage = percentage

        super(tag: tag || TAG)
      end

      def to_json_hash
        hash = {}
        hash.merge!(percentage_type_code_qualifier: find_identifier(:percentage_type_code_qualifier)) if @percentage_type_code_qualifier
        hash.merge!(percentage: @percentage) if @percentage
        hash
      end

      def segment_type
        TYPE
      end
    end
  end
end
