module Eancom
  module Edifact
    class RTE < Segment
      TAG = 'RTE'.freeze
      TYPE = :header

      attr_reader :segment_type

      def initialize(
        tag: nil,
        rate_type_code_qualifier: nil,
        unit_price_basis_rate: nil
      )
        @tag = tag
        @rate_type_code_qualifier = rate_type_code_qualifier
        @unit_price_basis_rate = unit_price_basis_rate

        super(tag: tag || TAG)
      end

      def to_json_hash
        hash = {}
        hash.merge!(rate_type_code_qualifier: find_identifier(:rate_type_code_qualifier)) if @rate_type_code_qualifier
        hash.merge!(unit_price_basis_rate: @unit_price_basis_rate) if @unit_price_basis_rate
        hash
      end

      def segment_type
        TYPE
      end
    end
  end
end
