module Eancom
  module Edifact
    class TOD < Segment
      TAG = 'TOD'.freeze
      TYPE = :header

      attr_reader :segment_type
      
      def initialize(
        tag: nil,
        delivery_or_transport_terms_function_code: nil,
        delivery_or_transport_terms_description_code: nil
      )
        @tag = tag
        @delivery_or_transport_terms_function_code = delivery_or_transport_terms_function_code
        @delivery_or_transport_terms_description_code = delivery_or_transport_terms_description_code

        super(tag: tag || TAG)
      end

      def to_json_hash
        hash = {}
        hash.merge!(delivery_or_transport_terms_function_code: @delivery_or_transport_terms_function_code) if @delivery_or_transport_terms_function_code
        hash.merge!(delivery_or_transport_terms_description_code: @delivery_or_transport_terms_description_code) if @delivery_or_transport_terms_description_code
        hash
      end

      def segment_type
        TYPE
      end
    end
  end
end
