module Eancom
  module Edifact
    class UNA < Segment
      TAG = 'UNA'.freeze
      TYPE = :header.freeze

      attr_reader :tag, :una1, :una2, :una3, :una4, :una5, :una6

      def initialize(tag: nil,
                     una1: ':',
                     una2: '+',
                     una3: '.',
                     una4: '?',
                     una5: ' ',
                     una6: '\'',
                     **kwargs
                    )
        @tag = tag
        @una1 = una1
        @una2 = una2
        @una3 = una3
        @una4 = una4
        @una5 = una5
        @una6 = una6

        super(tag: (tag || TAG))
      end


      def to_s
        stream = ""
        stream << tag
        stream << una1
        stream << una2
        stream << una3
        stream << una4
        stream << una5
        stream << una6
        stream
      end

      def to_json_hash
        {}
      end

      def segment_type
        TYPE
      end

    end
  end
end
